<script lang="ts">
import Vue from 'vue';
import SlpHorizontalRule from './horizontal-rule.vue';

export default Vue.extend({
  name: 'PullQuote',
  components: {
    SlpHorizontalRule,
  },
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
});
</script>

<template>
  <SlpContainer
    :class="{ [`variant-${data.variant}`]: data.variant }"
    :data-aos="data.aos_animation"
    :data-aos-duration="data.aos_duration"
  >
    <div
      class="container"
      aria-live="polite"
      :class="{
        'slp-mb-md-96': data.hide_horizontal_rule && !data.compact,
      }"
    >
      <div v-if="data.image" class="image-container">
        <nuxt-img
          v-if="data.image"
          class="quote-image"
          :src="data.image.image_url"
          :alt="data.image.image_alt"
          loading="lazy"
          format="webp"
          quality="99"
        />
      </div>
      <svg width="30" height="25" fill="#000000" class="quote-icon">
        <path
          d="M10.79.19C4.07 3.48.85 8.59.85 15.17c0 5.74 2.24 9.17 6.58 9.17 3.08 0 5.39-2.24 5.39-5.74 0-3.15-2.45-5.11-5.39-5.11-.21 0-.49 0-.7.07 0-4.2 2.1-6.79 6.3-8.89L10.79.19zm16.59 0c-6.72 3.29-10.01 8.4-10.01 14.98 0 5.74 2.31 9.17 6.65 9.17 3.08 0 5.32-2.24 5.32-5.74 0-3.15-2.38-5.11-5.32-5.11-.21 0-.49 0-.7.07 0-4.2 2.1-6.79 6.3-8.89L27.38.19z"
          fill="#000000"
        />
      </svg>
      <SlpTypography tag="p" variant="quotes" class="quote">{{
        data.quote
      }}</SlpTypography>
      <SlpTypography
        v-if="data.source"
        tag="p"
        variant="body1"
        class="source"
        >{{ data.source }}</SlpTypography
      >
      <div v-else-if="data.author" class="author">
        <SlpTypography variant="body3-bold" tag="p">{{
          data.author.name || data.author
        }}</SlpTypography>
        <SlpTypography variant="body3" tag="p">{{
          data.title || data.author.role
        }}</SlpTypography>
        <SlpTypography variant="body3" tag="p">{{
          data.company || data.author.company
        }}</SlpTypography>
      </div>
      <cite class="cite">{{ data.cite }}</cite>
      <a
        v-if="data.link_href"
        :href="data.link_href"
        class="slp-mb-16 slp-text-xxs quote-link"
        variant="primary"
        :data-ga-name="data.data_ga_name"
        :data-ga-location="data.data_ga_location"
        :aria-label="data.data_ga_name"
      >
        <SlpTypography variant="body1"> {{ data.link_text }} → </SlpTypography>
      </a>
    </div>
    <SlpHorizontalRule v-if="!data.hide_horizontal_rule" />
  </SlpContainer>
</template>

<style lang="scss" scoped>
.container {
  display: flex;
  padding: 48px 32px;
  flex-direction: column;
  align-items: flex-start;
  gap: 24px;
  border-radius: 8px 8px 40px 8px;
  background: $color-surface-800;

  @media (max-width: $breakpoint-lg) {
    padding: $spacing-48;
  }

  @media (max-width: $breakpoint-md) {
    padding: $spacing-24;
  }

  .image-container {
    display: flex;
    width: 100%;
    justify-content: space-between;
    align-items: center;
    margin-bottom: $spacing-48;
  }

  .quote {
    font-style: italic;
    margin-bottom: $spacing-32;
  }

  .quote-icon {
    margin-bottom: $spacing-32;
  }

  .source {
    font-weight: 700;
  }
  .author {
    display: flex;
    flex-direction: column;
  }

  .cite {
    font-style: normal;
    font-size: 10px;
    letter-spacing: 1.5px;
  }

  .quote-image {
    max-width: 160px;
    height: 65px;
    object-fit: contain;
  }

  .quote-button {
    border: 1px solid $color-text-link-100;
    width: 40px;
    height: 40px;
    border-radius: 30px;
    background: white;
    position: absolute;
    right: -20px;
    color: $color-text-link-100;
    cursor: pointer;
    display: flex;
    align-items: center;
    justify-content: center;
  }

  a {
    color: $color-text-link-100;
    font-size: 14px;
    line-height: 2rem;
    letter-spacing: 1px;
    margin-bottom: $spacing-48;

    &:hover {
      text-decoration: underline;
    }
  }
}

section {
  &.variant {
    &-compact {
      .container {
        text-align: left;
        padding: 54px $spacing-32;
        .quote-image,
        .quote-icon,
        .quote-link {
          align-self: flex-start;
        }

        .quote-icon {
          margin-bottom: $spacing-24;
        }

        .source {
          align-self: flex-start;
          font-weight: 400;
          font-size: 16px;
          line-height: 24px;
        }

        a {
          letter-spacing: 0;
        }
      }
    }
  }
}
</style>
